// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004, 29.11.2007

abstract class Set {

// datenstrukturabhaengige, abstrakte Methoden:

    // liefert Enumeration ueber die Menge:
    public abstract Enumeration getEnumeration();

    // Einfuegen eines Elementes:
    public abstract void insert(Object o);

    // Entfernen eines Elementes:
    public abstract void delete(Object o);

// datenstrukturunabhaengige Methoden:

    // Abfrage, ob Menge leer ist:
    public boolean isEmpty() {
	return size() == 0;
    }

    // Abfrage, ob Element enthalten ist:
    public boolean contains(Object o) {

	Enumeration enu = getEnumeration();

	while (enu.hasMoreElements()) {
	   Object item = enu.nextElement();
	   // Falls gefunden:
	   if (item.equals(o))
	      return true;
	}
	// i nicht gefunden:
	return false;
    }

    // Abfrage nach Groesse der Menge:
    public int size() {

	int result = 0;
	Enumeration enu = getEnumeration();
	while (enu.hasMoreElements()) {
	   result++;
	   Object dummy = enu.nextElement();
	}
	return result;
    }

    // Abfrage nach Teilmengeneigenschaft:
    public boolean isSubset(Set s) {

	Enumeration enu = getEnumeration();

	while (enu.hasMoreElements()) {

	    if (! s.contains(enu.nextElement()))
	       return false;
	}
	// Teilmengeneigenschaft ist nie verletzt:
	return true;
    }

    // Ausgabefunktion:
    public String toString() {
	String result = "{";
	Enumeration enu = getEnumeration();
	while (enu.hasMoreElements()) {
	   result += enu.nextElement();
	   if (enu.hasMoreElements())
	      result += ",";
	}
	return result + "}";
    }
}
